searchNodes=[{"doc":"Public API Example workflow: # the model is to be stored under /base/directory/model_name # the model will be created using specified options if not found { :ok , model } = Markov . load ( &quot;/base/directory&quot; , &quot;model_name&quot; , sanitize_tokens : true , store_history : [ :train ] ) # train using four strings { :ok , _ } = Markov . train ( model , &quot;hello, world!&quot; ) { :ok , _ } = Markov . train ( model , &quot;example string number two&quot; ) { :ok , _ } = Markov . train ( model , &quot;hello, Elixir!&quot; ) { :ok , _ } = Markov . train ( model , &quot;fourth string&quot; ) # generate text { :ok , text } = Markov . generate_text ( model ) IO . inspect ( text ) # unload model from RAM Markov . unload ( model ) # these will return errors because the model is unloaded # Markov.generate_text(model) # Markov.train(model, &quot;hello, world!&quot;) # load the model again { :ok , model } = Markov . load ( &quot;/base/directory&quot; , &quot;model_name&quot; ) # enable probability shifting and generate text :ok = Markov . configure ( model , shift_probabilities : true ) { :ok , text } = Markov . generate_text ( model ) IO . inspect ( text ) # print uninteresting stats model |&gt; Markov . dump_partition ( 0 ) |&gt; IO . inspect model |&gt; Markov . read_log |&gt; IO . inspect # this will also write our new just-set option Markov . unload ( model )","ref":"Markov.html","title":"Markov","type":"module"},{"doc":"Reconfigures an already loaded model. See model_option/0 for a thorough description of the options","ref":"Markov.html#configure/2","title":"Markov.configure/2","type":"function"},{"doc":"Reads an entire partition for debugging purposes","ref":"Markov.html#dump_partition/2","title":"Markov.dump_partition/2","type":"function"},{"doc":"Predicts (generates) a string. Will raise an exception if the model was trained on non-textual tokens at least once iex&gt; Markov . generate_text ( model ) { :ok , &quot;hello world&quot; } See type tag_query/0 for more info about tags","ref":"Markov.html#generate_text/2","title":"Markov.generate_text/2","type":"function"},{"doc":"Predicts (generates) a list of tokens iex&gt; Markov . generate_tokens ( model ) { :ok , [ &quot;hello&quot; , &quot;world&quot; ] } See type tag_query/0 for more info about tags","ref":"Markov.html#generate_tokens/2","title":"Markov.generate_tokens/2","type":"function"},{"doc":"Gets the configuration of an already loaded model","ref":"Markov.html#get_config/1","title":"Markov.get_config/1","type":"function"},{"doc":"Loads an existing model from base_dir / name . If none is found, a new model with the specified options at that path will be created and loaded, and if that fails, an error will be returned","ref":"Markov.html#load/3","title":"Markov.load/3","type":"function"},{"doc":"Deletes model data. There's no going back :)","ref":"Markov.html#nuke/1","title":"Markov.nuke/1","type":"function"},{"doc":"Reads the log file and returns a list of entries in chronological order iex&gt; Markov . read_log ( model ) { :ok , [ { ~U[2022-10-02 16:59:51.844Z] , :start , nil } , { ~U[2022-10-02 16:59:56.705Z] , :train , [ &quot;hello&quot; , &quot;world&quot; ] } ] }","ref":"Markov.html#read_log/1","title":"Markov.read_log/1","type":"function"},{"doc":"Trains model using text or a list of tokens. { :ok , _ } = Markov . train ( model , &quot;Hello, world!&quot; ) { :ok , _ } = Markov . train ( model , &quot;this is a string that&#39;s broken down into tokens behind the scenes&quot; ) { :ok , _ } = Markov . train ( model , [ :this , &quot;is&quot; , &#39;a token&#39; , :list , &quot;where&quot; , { :each_element , :is , { :taken , :as_is } } , :and , :can_be , :erlang . make_ref ( ) , &quot;&lt;-- any term&quot; ] ) Returns the status of the operation: :done - training is complete :deferred - a repartition is currently in progress, this request has been placed in the backlog to be fulfilled after repartitioning is complete See generate_text/2 for more info about specifiers","ref":"Markov.html#train/3","title":"Markov.train/3","type":"function"},{"doc":"Unloads an already loaded model","ref":"Markov.html#unload/1","title":"Markov.unload/1","type":"function"},{"doc":"","ref":"Markov.html#t:log_entry_type/0","title":"Markov.log_entry_type/0","type":"type"},{"doc":"Model options that could be set during creation in a call to load/3 or with configure/2 : store_history : determines what data to put in the operation log, all of them by default: :train : training requests :train_deferred : training requests that have been deferred to until after repartitioning is complete :gen : generation results :repart_start - repartition start :repart_done - repartition done :start - model is loaded :end - model is unloaded shift_probabilities : gives less popular generation paths more chance to get used, which makes the output more original but may produce nonsense; false by default partition_size : approximate number of link entries in one partition, 10k by default partition_timeout : partition is unloaded from RAM after that many milliseconds of inactivity, 10k by default sanitize_tokens : ignores letter case and punctuation when switching states, but still keeps the output as-is; false by default, can't be changed once the model is created order : order of the chain, i.e. how many previous tokens the next one is based on; 2 by default, can never be changed once the model is created","ref":"Markov.html#t:model_option/0","title":"Markov.model_option/0","type":"type"},{"doc":"","ref":"Markov.html#t:model_reference/0","title":"Markov.model_reference/0","type":"opaque"},{"doc":"If data was tagged when training, you can use tag queries to only select generation paths that match a set of criteria true always matches {x, :or, y} matches when either x or y matches {:not, x} matches if x doesn't match, and vice versa {x, :score, y} is only allowed at the top level; the total score counter (initially 0) is increased by score for every element {query, score} of y (a list) that matches; probabilities are then adjusted according to those scores. any other term is treated as a tag (note the :&quot;$none&quot; tag - the default one) Examples: # training iex&gt; Markov . train ( model , &quot;hello earth&quot; , [ { :action , :saying_hello } , # &lt;- terms of any type can function as tags { :subject_type , :planet } , { :subject , &quot;earth&quot; } , :lowercase ] ) { :ok , :done } iex&gt; Markov . train ( model , &quot;Hello Elixir&quot; , [ { :action , :saying_hello } , { :subject_type , :programming_language } , { :subject , &quot;Elixir&quot; } , :uppercase ] ) { :ok , :done } # simple generation - both paths have equal probabilities iex&gt; Markov . generate_text ( model ) { :ok , &quot;hello earth&quot; } iex&gt; Markov . generate_text ( model ) { :ok , &quot;hello Elixir&quot; } # simple tag queries iex&gt; Markov . generate_text ( model , { :subject_type , :planet } ) { :ok , &quot;hello earth&quot; } iex&gt; Markov . generate_text ( model , :lowercase ) { :ok , &quot;hello earth&quot; } iex&gt; Markov . generate_text ( model , { :subject_type , :programming_language } ) { :ok , &quot;hello Elixir&quot; } iex&gt; Markov . generate_text ( model , :uppercase ) { :ok , &quot;hello Elixir&quot; } # both possible generation paths were tagged with this tag iex&gt; Markov . generate_text ( model , { :action , :saying_hello } ) { :ok , &quot;hello earth&quot; } iex&gt; Markov . generate_text ( model , { :action , :saying_hello } ) { :ok , &quot;hello Elixir&quot; } # both paths match, but &quot;hello Elixir&quot; has a score of 1 and &quot;hello earth&quot; # has a score of zero; thus, &quot;hello Elixir&quot; has a probability of 2/3, and # &quot;hello earth&quot; has that of 1/3 iex&gt; Markov . generate_text ( model , { true , :score , [ :uppercase ] } ) { :ok , &quot;hello Elixir&quot; } iex&gt; Markov . generate_text ( model , { true , :score , [ :uppercase ] } ) { :ok , &quot;hello earth&quot; }","ref":"Markov.html#t:tag_query/0","title":"Markov.tag_query/0","type":"type"},{"doc":"Markov OTP app","ref":"Markov.App.html","title":"Markov.App","type":"module"},{"doc":"Loads the dictionary for prompt generation into a ets table","ref":"Markov.DictionaryHolder.html","title":"Markov.DictionaryHolder","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Markov.DictionaryHolder.html#child_spec/1","title":"Markov.DictionaryHolder.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Markov.DictionaryHolder.html#init/1","title":"Markov.DictionaryHolder.init/1","type":"function"},{"doc":"","ref":"Markov.DictionaryHolder.html#start_link/1","title":"Markov.DictionaryHolder.start_link/1","type":"function"},{"doc":"","ref":"Markov.ListUtil.html","title":"Markov.ListUtil","type":"module"},{"doc":"Splits the list into size -sized lists of consecutive elements Example iex&gt; Markov.ListUtil . overlapping_stride ( [ :a , :b , :c , :d , :e , :f , :g ] , 3 ) [ [ :a , :b , :c ] , [ :b , :c , :d ] , [ :c , :d , :e ] , [ :d , :e , :f ] , [ :e , :f , :g ] ] iex&gt; Markov.ListUtil . overlapping_stride ( [ :a , :b , :c , :d , :e , :f , :g ] , 2 ) [ [ :a , :b ] , [ :b , :c ] , [ :c , :d ] , [ :d , :e ] , [ :e , :f ] , [ :f , :g ] ]","ref":"Markov.ListUtil.html#overlapping_stride/2","title":"Markov.ListUtil.overlapping_stride/2","type":"function"},{"doc":"Performs training, generation and probability shifting. Supposed to only ever be used by Markov.ModelServer s.","ref":"Markov.ModelActions.html","title":"Markov.ModelActions","type":"module"},{"doc":"Adjust the probabilities of a batch of connections","ref":"Markov.ModelActions.html#adjust_batch_probs/1","title":"Markov.ModelActions.adjust_batch_probs/1","type":"function"},{"doc":"Adjusts the probability of one connection","ref":"Markov.ModelActions.html#adjust_one_prob/1","title":"Markov.ModelActions.adjust_one_prob/1","type":"function"},{"doc":"","ref":"Markov.ModelActions.html#generate/2","title":"Markov.ModelActions.generate/2","type":"function"},{"doc":"","ref":"Markov.ModelActions.html#next_state/3","title":"Markov.ModelActions.next_state/3","type":"function"},{"doc":"processes { , :score, } tag queries","ref":"Markov.ModelActions.html#process_scores/4","title":"Markov.ModelActions.process_scores/4","type":"function"},{"doc":"tag query to match specification","ref":"Markov.ModelActions.html#tq2ms/2","title":"Markov.ModelActions.tq2ms/2","type":"function"},{"doc":"tag query to match spec condition","ref":"Markov.ModelActions.html#tq2msc/1","title":"Markov.ModelActions.tq2msc/1","type":"function"},{"doc":"","ref":"Markov.ModelActions.html#train/3","title":"Markov.ModelActions.train/3","type":"function"},{"doc":"","ref":"Markov.ModelActions.html#walk_chain/5","title":"Markov.ModelActions.walk_chain/5","type":"function"},{"doc":"GenServer in charge of one model Terminology: The master is the file that persists a server's state (incl. repartitioning data, options, etc.) A partition is a dets table that holds a preconfigured number of chain links. Repartitioning occurs when, as a result of a training operation, the estimated average number of links in one partition has exceeded the preconfigured amount, so a new partition is created and data from the old ones is reshuffled between all new available partitions. Assuming this Markov.load/3 call: Markov . load ( &quot;/basepath&quot; , &quot;model_name&quot; ) This is the model structure on disk: basepath model_name master.etf.gz - the master in gzipped Erlang's External Term Format operation_log.csetf - the operation log in Concatenated Sized External Term Format. Each log entry is encoded in ETF, preceded with its 16-bit size in bytes and appended to the log. part_0.dets - partition number 0, a DETS table part_n.dets - partition number n","ref":"Markov.ModelServer.html","title":"Markov.ModelServer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Markov.ModelServer.html#child_spec/1","title":"Markov.ModelServer.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.handle_continue/2 .","ref":"Markov.ModelServer.html#handle_continue/2","title":"Markov.ModelServer.handle_continue/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Markov.ModelServer.html#init/1","title":"Markov.ModelServer.init/1","type":"function"},{"doc":"","ref":"Markov.ModelServer.html#open_partition!/2","title":"Markov.ModelServer.open_partition!/2","type":"function"},{"doc":"","ref":"Markov.ModelServer.html#start/1","title":"Markov.ModelServer.start/1","type":"function"},{"doc":"","ref":"Markov.ModelServer.html#start_link/1","title":"Markov.ModelServer.start_link/1","type":"function"},{"doc":"","ref":"Markov.ModelServer.html#t:start_options/0","title":"Markov.ModelServer.start_options/0","type":"type"},{"doc":"","ref":"Markov.ModelServer.State.html","title":"Markov.ModelServer.State","type":"module"},{"doc":"","ref":"Markov.ModelServer.State.html#t:t/0","title":"Markov.ModelServer.State.t/0","type":"type"},{"doc":"Asks the model server to unload a partition after some time of inactivity","ref":"Markov.PartTimeout.html","title":"Markov.PartTimeout","type":"module"},{"doc":"","ref":"Markov.PartTimeout.html#start_link/3","title":"Markov.PartTimeout.start_link/3","type":"function"},{"doc":"Thin wrapper around Markov to make the chain respond to prompts assuming it's been trained on the appropriate data","ref":"Markov.Prompt.html","title":"Markov.Prompt","type":"module"},{"doc":"Generates the text from a prompt","ref":"Markov.Prompt.html#generate_prompted/2","title":"Markov.Prompt.generate_prompted/2","type":"function"},{"doc":"Assuming your application receives a stream of strings, call this function instead of Markov.train/3 with the current and last string","ref":"Markov.Prompt.html#train/3","title":"Markov.Prompt.train/3","type":"function"},{"doc":"Trains the model on a list of consecutive strings","ref":"Markov.Prompt.html#train_on_list/2","title":"Markov.Prompt.train_on_list/2","type":"function"},{"doc":"Main supervisor","ref":"Markov.Sup.html","title":"Markov.Sup","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Markov.Sup.html#child_spec/1","title":"Markov.Sup.child_spec/1","type":"function"},{"doc":"","ref":"Markov.Sup.html#start_link/1","title":"Markov.Sup.start_link/1","type":"function"},{"doc":"","ref":"Markov.Sup.html#stop/0","title":"Markov.Sup.stop/0","type":"function"},{"doc":"","ref":"Markov.TextUtil.html","title":"Markov.TextUtil","type":"module"},{"doc":"Strips textual tokens of preceding and trailing non-word characters and downcases them iex&gt; Markov.TextUtil . sanitize_token ( :atom ) :atom iex&gt; Markov.TextUtil . sanitize_token ( &quot;test&quot; ) &quot;test&quot; iex&gt; Markov.TextUtil . sanitize_token ( &quot; !!!???/// tEsT &gt;&gt;&gt;&quot; ) &quot;test&quot;","ref":"Markov.TextUtil.html#sanitize_token/1","title":"Markov.TextUtil.sanitize_token/1","type":"function"},{"doc":"Text generation library based on nth-order Markov chains","ref":"readme.html","title":"Markov","type":"extras"},{"doc":"Token sanitation (optional): ignores letter case and punctuation when switching states, but still keeps the output as-is Operation history (optional): recalls the operations it was instructed to perform, incl. past training data Probability shifting (optional): gives less popular generation paths more chance to get used, which makes the output more original but may produce nonsense Tagging (optional): you can tag your source data to be queried later by aggregating those tags in any way you want, kind of like a database Context awareness (optional) grants your model the ability to answer questions given to it provided training data is good enough Managed disk storage Transparent fragmentation reduces RAM usage and loading times with huge models","ref":"readme.html#features","title":"Markov - Features","type":"extras"},{"doc":"In mix.exs : defp deps do [ { :markov , &quot;~&gt; 2.1&quot; } ] end Unlike Markov 1.x, this version has very strong opinions on how you should create and persist your models. Example workflow (click here for full docs): # the model is to be stored under /base/directory/model_name # the model will be created using specified options if not found { :ok , model } = Markov . load ( &quot;/base/directory&quot; , &quot;model_name&quot; , sanitize_tokens : true , store_history : [ :train ] ) # train using four strings { :ok , _ } = Markov . train ( model , &quot;hello, world!&quot; ) { :ok , _ } = Markov . train ( model , &quot;example string number two&quot; ) { :ok , _ } = Markov . train ( model , &quot;hello, Elixir!&quot; ) { :ok , _ } = Markov . train ( model , &quot;fourth string&quot; ) # generate text { :ok , text } = Markov . generate_text ( model ) IO . inspect ( text ) # unload model from RAM Markov . unload ( model ) # these will return errors because the model is unloaded # Markov.generate_text(model) # Markov.train(model, &quot;hello, world!&quot;) # load the model again { :ok , model } = Markov . load ( &quot;/base/directory&quot; , &quot;model_name&quot; ) # enable probability shifting and generate text :ok = Markov . configure ( model , shift_probabilities : true ) { :ok , text } = Markov . generate_text ( model ) IO . inspect ( text ) # print uninteresting stats model |&gt; Markov . dump_partition ( 0 ) |&gt; IO . inspect model |&gt; Markov . read_log |&gt; IO . inspect # this will also write our new just-set option Markov . unload ( model )","ref":"readme.html#usage","title":"Markov - Usage","type":"extras"},{"doc":"The English dictionary in a CSV format","ref":"readme.html#credits","title":"Markov - Credits","type":"extras"}]